library container;

import 'dart:html';
import 'dart:async';
import 'package:built_value/built_value.dart';
import 'package:wui_builder/wui_builder.dart';
import 'package:wui_builder/functional.dart';
import 'package:wui_builder/vsvg.dart';

part 'container.g.dart';

abstract class ContainerState
    implements Built<ContainerState, ContainerStateBuilder> {
  ContainerState._();
  factory ContainerState(int height, int width) =>
      new _$ContainerState._(height: height, width: width);

  int get height;

  int get width;
}

class Container extends Component<Null, ContainerState> {
  StreamSubscription _sub;

  Container(Null props) : super(props);

  @override
  ContainerState getInitialState() => _newState;

  @override
  void componentWillMount() {
    _sub = window.onResize.listen((_) => _setSize);
  }

  @override
  void componentWillUnmount() {
    _sub.cancel();
  }

  @override
  render() => new VSvgSvgElement()
    ..attributes = {
      'height': '${state.height}',
      'width': '${state.width}',
      'viewBox': '0 0 1000 1000',
    }
    ..children = [
      pure<Null>((_) => props)(null),
    ];

  void _setSize() {
    setState((_, __) => _newState);
  }

  ContainerState get _newState =>
      new ContainerState(window.innerWidth ~/ 1000, window.innerHeight ~/ 1000);
}
