library location;

import 'package:built_value/built_value.dart';
import 'package:wui_builder/wui_builder.dart';
import 'package:wui_builder/vsvg.dart';

import 'models/tetromino.dart';

part 'location.g.dart';

abstract class LocationProps
    implements Built<LocationProps, LocationPropsBuilder> {
  LocationProps._();
  factory LocationProps(void updates(LocationPropsBuilder b)) = _$LocationProps;

  Tetromino get tetromino;

  int get x;

  int get y;
}

class Location extends Component<LocationProps, Null> {
  Location(LocationProps props) : super(props);

  @override
  render() => new VRectElement()
    ..attributes = {
      'height': '25',
      'width': '25',
      'x': '${props.x * 25}',
      'y': '${props.y * 25}',
      'fill': props.tetromino.color,
    };
}
