library tetromino;

import 'dart:math' hide Point;
import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'enums.dart';
import 'point.dart';

part 'tetromino.g.dart';

abstract class Tetromino implements Built<Tetromino, TetrominoBuilder> {
  Tetromino._();

  String get color;

  Tetrominos get type;

  Orientation get orientation;

  BuiltList<Point> get points;

  factory Tetromino.O() => new _$Tetromino._(
        color: '#ffff00',
        type: Tetrominos.O,
        orientation: Orientation.Zero,
        points: new BuiltList<Point>(<Point>[
          new Point(0, 0),
        ]),
      );
  factory Tetromino.I() => new _$Tetromino._(
        color: '#00ffff',
        type: Tetrominos.I,
        orientation: Orientation.Zero,
        points: new BuiltList<Point>(<Point>[
          new Point(0, 0),
        ]),
      );
  factory Tetromino.L() => new _$Tetromino._(
        color: '#ffa500',
        type: Tetrominos.L,
        orientation: Orientation.Zero,
        points: new BuiltList<Point>(<Point>[
          new Point(0, 0),
        ]),
      );
  factory Tetromino.J() => new _$Tetromino._(
        color: '#0000ff',
        type: Tetrominos.J,
        orientation: Orientation.Zero,
        points: new BuiltList<Point>(<Point>[
          new Point(0, 0),
        ]),
      );
  factory Tetromino.S() => new _$Tetromino._(
        color: '#00ff00',
        type: Tetrominos.S,
        orientation: Orientation.Zero,
        points: new BuiltList<Point>(<Point>[
          new Point(0, 0),
        ]),
      );
  factory Tetromino.Z() => new _$Tetromino._(
        color: '#ff0000',
        type: Tetrominos.Z,
        orientation: Orientation.Zero,
        points: new BuiltList<Point>(<Point>[
          new Point(0, 0),
        ]),
      );
  factory Tetromino.T() => new _$Tetromino._(
        color: '#551A8B',
        type: Tetrominos.T,
        orientation: Orientation.Zero,
        points: new BuiltList<Point>(<Point>[
          new Point(0, 0),
        ]),
      );

  factory Tetromino.Random() {
    Tetrominos random =
        Tetrominos.values[(new Random()).nextInt(Tetrominos.values.length)];
    switch (random) {
      case Tetrominos.O:
        return new Tetromino.O();
      case Tetrominos.I:
        return new Tetromino.I();
      case Tetrominos.L:
        return new Tetromino.L();
      case Tetrominos.J:
        return new Tetromino.J();
      case Tetrominos.S:
        return new Tetromino.S();
      case Tetrominos.Z:
        return new Tetromino.Z();
      case Tetrominos.T:
        return new Tetromino.T();
      default:
        throw new Exception('_randomTetromino default case');
    }
  }
}
